Attribute VB_Name = "mRender"
Option Explicit

Public Sub Render()
    Dim vertexSize As Single
    Dim sizeVert As VERTEX
    Dim sizeNormVert As NORMALVERTEX
    
    vertexSize = IIf(appLighting = True, Len(sizeNormVert), Len(sizeVert))
    
    
        D3DDevice.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, RGB(225, 100, 100), 1#, 0
        D3DDevice.BeginScene
         
        D3DDevice.SetStreamSource 0, vertexBuffer, vertexSize
        
        If appLighting = False Then
            D3DDevice.SetVertexShader FVF_VERTEX
        Else
            D3DDevice.SetVertexShader NORMAL_FVF
        End If
        
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 8
       
        
        D3DDevice.EndScene
        D3DDevice.Present ByVal 0, ByVal 0, 0, ByVal 0
        
End Sub


